Package de.willuhn.jameica.hbci.server

# Class AbstractBaseDauerauftragImpl

java.lang.Object
java.rmi.server.RemoteObject
java.rmi.server.RemoteServer
java.rmi.server.UnicastRemoteObject
de.willuhn.datasource.db.AbstractDBObject
de.willuhn.jameica.hbci.server.AbstractHibiscusDBObject
de.willuhn.jameica.hbci.server.AbstractHibiscusTransferImpl
de.willuhn.jameica.hbci.server.AbstractBaseDauerauftragImpl

All Implemented Interfaces:
  `de.willuhn.datasource.GenericObject`, `de.willuhn.datasource.rmi.Changeable`, `de.willuhn.datasource.rmi.DBObject`, `de.willuhn.datasource.rmi.Transactionable`, `BaseDauerauftrag`, `Checksum`, `HibiscusDBObject`, `HibiscusTransfer`, `Transfer`, `Serializable`, `Remote`

Direct Known Subclasses:
  `DauerauftragImpl`, `SepaDauerauftragImpl`

public abstract class AbstractBaseDauerauftragImpl extends AbstractHibiscusTransferImpl implements BaseDauerauftrag
Abstrakte Basis-Implementierung eines Dauerauftrags.

See Also:
  - Serialized Form

## Field Summary

### Fields inherited from class java.rmi.server.RemoteObject

`ref`

### Fields inherited from interface de.willuhn.jameica.hbci.rmi.BaseDauerauftrag

`ORDERID_PLACEHOLDER`

## Constructor Summary

Constructors
Constructor
Description
`AbstractBaseDauerauftragImpl()`
ct.

## Method Summary

Modifier and Type
Method
Description
`boolean`
`equals(de.willuhn.datasource.GenericObject o)`
`Object`
`getAttribute(String arg0)`
`Date`
`getErsteZahlung()`
Liefert das Datum der ersten Zahlung.
`Date`
`getLetzteZahlung()`
Liefert das Datum der letzten Zahlung oder `null`, wenn kein Zahlungsende definiert ist.
`Date`
`getNaechsteZahlung()`
BUGZILLA 204 Liefert das voraussichtliche Datum der naechsten Zahlung.
`String`
`getOrderID()`
Liefert die eindeutige ID von der Bank.
`String`
`getPrimaryAttribute()`
`Turnus`
`getTurnus()`
Liefert den Zahlungsturnus fuer diesen Dauerauftrag.
`boolean`
`isActive()`
Liefert `true` wenn der Dauerauftrag bei der Bank aktiv ist.
`void`
`setErsteZahlung(Date datum)`
Legt das Datum fuer die erste Zahlung fest.
`void`
`setLetzteZahlung(Date datum)`
Legt das Datum fuer die letzte Zahlung fest.
`void`
`setOrderID(String id)`
Speichert die Order-ID des Dauerauftrages.
`void`
`setTurnus(Turnus turnus)`
Legt den Zahlungsturnus fest.

### Methods inherited from class de.willuhn.jameica.hbci.server.AbstractHibiscusTransferImpl

`delete, getBetrag, getGegenkontoBLZ, getGegenkontoName, getGegenkontoNummer, getKonto, getWeitereVerwendungszwecke, getZweck, getZweck2, insertCheck, overwrite, setBetrag, setGegenkonto, setGegenkontoBLZ, setGegenkontoName, setGegenkontoNummer, setKonto, setWeitereVerwendungszwecke, setZweck, setZweck2, store, updateCheck`

### Methods inherited from class de.willuhn.jameica.hbci.server.AbstractHibiscusDBObject

`getMeta, setMeta`

### Methods inherited from class de.willuhn.datasource.db.AbstractDBObject

`addDeleteListener, addStoreListener, clear, deleteCheck, getAttributeNames, getAttributeType, getForeignObject, getID, getIDField, getInsertSQL, getList, getListQuery, getLoadQuery, getService, getTableName, getUpdateSQL, hasChanged, hasChanged, init, insert, isNewObject, load, removeDeleteListener, removeStoreListener, setAttribute, setID, setService, transactionBegin, transactionCommit, transactionRollback`

### Methods inherited from class java.rmi.server.UnicastRemoteObject

`clone, exportObject, exportObject, exportObject, exportObject, exportObject, unexportObject`

### Methods inherited from class java.rmi.server.RemoteServer

`getClientHost, getLog, setLog`

### Methods inherited from class java.rmi.server.RemoteObject

`equals, getRef, hashCode, toString, toStub`

### Methods inherited from class java.lang.Object

`finalize, getClass, notify, notifyAll, wait, wait, wait`

### Methods inherited from interface de.willuhn.jameica.hbci.rmi.BaseDauerauftrag

`delete`

### Methods inherited from interface de.willuhn.datasource.rmi.Changeable

`clear, isNewObject, overwrite, store`

### Methods inherited from interface de.willuhn.jameica.hbci.rmi.Checksum

`getChecksum`

### Methods inherited from interface de.willuhn.datasource.rmi.DBObject

`addDeleteListener, addStoreListener, getAttributeType, getList, load, removeDeleteListener, removeStoreListener`

### Methods inherited from interface de.willuhn.datasource.GenericObject

`getAttributeNames, getID`

### Methods inherited from interface de.willuhn.jameica.hbci.rmi.HibiscusDBObject

`getMeta, setMeta`

### Methods inherited from interface de.willuhn.jameica.hbci.rmi.HibiscusTransfer

`getKonto, setBetrag, setGegenkonto, setGegenkontoBLZ, setGegenkontoName, setGegenkontoNummer, setKonto, setWeitereVerwendungszwecke, setZweck, setZweck2`

### Methods inherited from interface de.willuhn.datasource.rmi.Transactionable

`transactionBegin, transactionCommit, transactionRollback`

### Methods inherited from interface de.willuhn.jameica.hbci.rmi.Transfer

`getBetrag, getGegenkontoBLZ, getGegenkontoName, getGegenkontoNummer, getWeitereVerwendungszwecke, getZweck, getZweck2`

## Constructor Details

### AbstractBaseDauerauftragImpl

public AbstractBaseDauerauftragImpl() throws RemoteException
ct.

Throws:
  `RemoteException`

## Method Details

### getPrimaryAttribute

public String getPrimaryAttribute() throws RemoteException

Specified by:
  `getPrimaryAttribute` in interface `de.willuhn.datasource.rmi.DBObject`
Specified by:
  `getPrimaryAttribute` in interface `de.willuhn.datasource.GenericObject`
Specified by:
  `getPrimaryAttribute` in class `de.willuhn.datasource.db.AbstractDBObject`
Throws:
  `RemoteException`
See Also:
  - `AbstractDBObject.getPrimaryAttribute()`

### getErsteZahlung

public Date getErsteZahlung() throws RemoteException
Description copied from interface: `BaseDauerauftrag`
Liefert das Datum der ersten Zahlung.

Specified by:
  `getErsteZahlung` in interface `BaseDauerauftrag`
Returns:
  erste Zahlung.
Throws:
  `RemoteException`
See Also:
  - `BaseDauerauftrag.getErsteZahlung()`

### getLetzteZahlung

public Date getLetzteZahlung() throws RemoteException
Description copied from interface: `BaseDauerauftrag`
Liefert das Datum der letzten Zahlung oder `null`, wenn kein Zahlungsende definiert ist.

Specified by:
  `getLetzteZahlung` in interface `BaseDauerauftrag`
Returns:
  Datum der letzten Zahlung oder `null`.
Throws:
  `RemoteException`
See Also:
  - `BaseDauerauftrag.getLetzteZahlung()`

### getTurnus

public Turnus getTurnus() throws RemoteException
Description copied from interface: `BaseDauerauftrag`
Liefert den Zahlungsturnus fuer diesen Dauerauftrag.

Specified by:
  `getTurnus` in interface `BaseDauerauftrag`
Returns:
  Zahlungsturnus des Dauerauftrags.
Throws:
  `RemoteException`
See Also:
  - `BaseDauerauftrag.getTurnus()`

### isActive

public boolean isActive() throws RemoteException
Description copied from interface: `BaseDauerauftrag`
Liefert `true` wenn der Dauerauftrag bei der Bank aktiv ist. Ob dieser nun von der Bank abgerufen oder lokal erstellt und dann eingereicht wurde, spielt keine Rolle. Entscheidend ist lediglich, dass er bei der Bank vorliegt und aktiv ist.

Specified by:
  `isActive` in interface `BaseDauerauftrag`
Returns:
  true, wenn der Dauerauftrag bei der Bank aktiv ist.
Throws:
  `RemoteException`
See Also:
  - `BaseDauerauftrag.isActive()`

### setErsteZahlung

public void setErsteZahlung(Date datum) throws RemoteException
Description copied from interface: `BaseDauerauftrag`
Legt das Datum fuer die erste Zahlung fest.

Specified by:
  `setErsteZahlung` in interface `BaseDauerauftrag`
Parameters:
  `datum` - Datum fuer die erste Zahlung.
Throws:
  `RemoteException`
See Also:
  - `BaseDauerauftrag.setErsteZahlung(java.util.Date)`

### setLetzteZahlung

public void setLetzteZahlung(Date datum) throws RemoteException
Description copied from interface: `BaseDauerauftrag`
Legt das Datum fuer die letzte Zahlung fest.

Specified by:
  `setLetzteZahlung` in interface `BaseDauerauftrag`
Parameters:
  `datum` - Datum fuer die letzte Zahlung. Kann `null` sein, wenn kein End-Datum definiert ist.
Throws:
  `RemoteException`
See Also:
  - `BaseDauerauftrag.setLetzteZahlung(java.util.Date)`

### setTurnus

public void setTurnus(Turnus turnus) throws RemoteException
Description copied from interface: `BaseDauerauftrag`
Legt den Zahlungsturnus fest.

Specified by:
  `setTurnus` in interface `BaseDauerauftrag`
Parameters:
  `turnus` - Zahlungsturnus des Dauerauftrags.
Throws:
  `RemoteException`
See Also:
  - `BaseDauerauftrag.setTurnus(de.willuhn.jameica.hbci.rmi.Turnus)`

### equals

public boolean equals(de.willuhn.datasource.GenericObject o) throws RemoteException

Specified by:
  `equals` in interface `de.willuhn.datasource.rmi.DBObject`
Specified by:
  `equals` in interface `de.willuhn.datasource.GenericObject`
Overrides:
  `equals` in class `de.willuhn.datasource.db.AbstractDBObject`
Throws:
  `RemoteException`
See Also:
  - `AbstractDBObject.equals(de.willuhn.datasource.GenericObject)`

### getOrderID

public String getOrderID() throws RemoteException
Description copied from interface: `BaseDauerauftrag`
Liefert die eindeutige ID von der Bank. Damit kann der Dauerauftrag bei Aenderungen wiedererkannt werden.

Specified by:
  `getOrderID` in interface `BaseDauerauftrag`
Returns:
  Order-ID.
Throws:
  `RemoteException`
See Also:
  - `BaseDauerauftrag.getOrderID()`

### setOrderID

public void setOrderID(String id) throws RemoteException
Description copied from interface: `BaseDauerauftrag`
Speichert die Order-ID des Dauerauftrages.

Specified by:
  `setOrderID` in interface `BaseDauerauftrag`
Parameters:
  `id` - die Order-ID.
Throws:
  `RemoteException`
See Also:
  - `BaseDauerauftrag.setOrderID(java.lang.String)`

### getAttribute

public Object getAttribute(String arg0) throws RemoteException

Specified by:
  `getAttribute` in interface `de.willuhn.datasource.rmi.DBObject`
Specified by:
  `getAttribute` in interface `de.willuhn.datasource.GenericObject`
Overrides:
  `getAttribute` in class `AbstractHibiscusTransferImpl`
Throws:
  `RemoteException`
See Also:
  - `AbstractDBObject.getAttribute(java.lang.String)`

### getNaechsteZahlung

public Date getNaechsteZahlung() throws RemoteException
Description copied from interface: `BaseDauerauftrag`
BUGZILLA 204 Liefert das voraussichtliche Datum der naechsten Zahlung. Liegt das Datum der ersten Zahlung in der Zukunft, wird dieses zurueckgeliefert. Liegt das Datum der letzten Zahlung in der Vergangenheit, gilt der Dauerauftrag als abgelaufen und es wird `null` zurueckgeliefert. Andernfalls wird anhand des Zahlungsturnus das naechste Zahl-Datum ermittelt.

Specified by:
  `getNaechsteZahlung` in interface `BaseDauerauftrag`
Returns:
  Datum der naechsten Zahlung.
Throws:
  `RemoteException`
See Also:
  - `BaseDauerauftrag.getNaechsteZahlung()`